\ Block 50 Audio Test Christof Eberspaecher
\ audioTest.fth Version for osc2UefC.cpp
0 audioxt ! \ stop audio callback
defined? myLibrary [IF] forget   my_Library [THEN]
variable my_Library

\ 2 constant ledPin \ ESP32
\ 31 constant ledPin \ Daisy Arduino

\ Audio Test #######################################################

defined? F-3 0= [IF]
: F-3 ( milli ) \ usage: 3141 f-3 to get 3.141 on fstack
   S>F 1000 S>F F/ ;
[THEN]

daisyControls constant dc
: setFreq ( Hz -- )
 s>f dc cell+ sf! ;
 150 setFreq
 
: setVolPm ( pm -- ) \ permille 0...1000
 s>f 1000 s>f f/ daisyControls sf! ;
 70 setVolPm

: flog10 ( fx -- flog10 ) \ auf dem fstack
   fln 10 s>f fln f/ ;
  
: setVoldB ( db ) \ 0...100
   dup 0= if 
      drop 0 s>f 
   else
      100 - s>f 20 s>f f/ 10 s>f fswap f**
   then
   daisyControls sf! ;
60 setvoldb  

: mute1 0 s>f daisyControls sf! ;

: cpuLoad.
   daisyControls 50 cells + sf@ f.
;
cpuload.

2000 value vcoMHz \ milliHz

: vco ( -- fosc ) \ generate sine float
   ms-ticks vcomHz 1000 */ 1000 mod  s>f \ get millis 
   500 s>f f/ pi f* fsin ;   

300 value frMid \ mid frequency in Hz
20 value frFacPc \ percentage of modulation

: fmodulate \ modulate frequency one time
   frmid s>f 
   frFacPc s>f 100 s>f f/
   vco f* \ get sine
   fover f* f+
   daisyControls cell+ sf!
;
\ ' fmodulate audioXt !

: modulate \ modulate until key is pressed (Test)
   key drop
   begin
      fmodulate
      pause
   key? until
;
\ modulate

: bgModulate \ background program
   begin
      fmodulate
      1 ms
   again
;

' bgModulate 100 100 task modulateTask
\ modulateTask start-task

\ Second Audio Oscillator done by Forth ####################

pi 2 s>f f* fconstant 2pi
fvariable deltaPh2 \ increment of phase 
96 s>f 1/f 2pi f* deltaPh2 sf!  
fvariable phase2  0 phase2 !
fvariable ampl2   50 f-3 ampl2 sf!

: setFreq2 ( frequ -- ) \ set frequency for osc2
   s>f 48000 s>f f/ 2pi f* deltaPh2 sf! ;
   
: mute2 0 ampl2 ! ;

: cbOsc \ Oscillator done by Forth as callback
   phase2 sf@ \ get phase
   48 0 do
      deltaPh2 sf@ f+ \ fdup f. \ add phase increment
      fdup fsin ampl2 sf@ f* \ calculate sine
      daisyAudio i cells + sf! \ store into buffer
   loop
   fdup 2pi f> if 2pi f- then 
   phase2 sf! \ store phase
;

\ cbosc \ fill the audio buffer
   
: daisyAudio. \ print audio buffer
   48 0 do
      daisyAudio i cells + sf@ f.
   loop
;

: audioLoop
   cbosc \ the oscillator done by Forth 
   fmodulate \ modulate the oscillator done by libDaisy
;

' audioloop audioxt ! \ activate callback

\ cpuload.

