
\ ceTestsA.fth Version for osc2UefC.cpp
0 audioxt ! \ stop audio callback
forget   my_Library
variable my_Library

\ 2 constant ledPin \ ESP32
\ 31 constant ledPin \ Daisy Arduino

\ Audio Test #######################################################
\ Block 50 for Audio
defined? F-3 0= [IF]
: F-3 ( milli ) \ usage: 3141 f-3 to get 3.141 on fstack
   S>F 1000 S>F F/ ;
[THEN]

daisyControls constant dc
: setFreq ( Hz -- )
 s>f dc cell+ sf! ;
 150 setFreq
 
: setVolPm ( pm -- ) \ permille 0...1000
 s>f 1000 s>f f/ daisyControls sf! ;
 70 setVolPm

: flog10 ( fx -- flog10 ) \ auf dem fstack
   fln 10 s>f fln f/ ;
  
: setVoldB ( db ) \ 0...100
   dup 0= if 
      drop 0 s>f 
   else
      100 - s>f 20 s>f f/ 10 s>f fswap f**
   then
   daisyControls sf! ;
60 setvoldb  

: mute1 0 s>f daisyControls sf! ;

: cpuLoad.
   daisyControls 50 cells + sf@ f.
;
cpuload.

2000 value vcoMHz \ milliHz

: vco ( -- fosc ) \ generate sine float
   ms-ticks vcomHz 1000 */ 1000 mod  s>f \ get millis 
   500 s>f f/ pi f* fsin ;   

300 value frMid \ mid frequency in Hz
20 value frFacPc \ percentage of modulation

: fmodulate \ modulate frequency one time
   frmid s>f 
   frFacPc s>f 100 s>f f/
   vco f* \ get sine
   fover f* f+
   daisyControls cell+ sf!
;
\ ' fmodulate audioXt !

: modulate \ modulate until key is pressed (Test)
   key drop
   begin
      fmodulate
      pause
   key? until
;
\ modulate

: bgModulate \ background program
   begin
      fmodulate
      1 ms
   again
;

' bgModulate 100 100 task modulateTask
\ modulateTask start-task

\ Second Audio Oscillator done by Forth

pi 2 s>f f* fconstant 2pi
fvariable deltaPh2 \ increment of phase 
96 s>f 1/f 2pi f* deltaPh2 sf!  
fvariable phase2  0 phase2 !
fvariable ampl2   50 f-3 ampl2 sf!

: setFreq2 ( frequ -- ) \ set frequency for osc2
   s>f 48000 s>f f/ 2pi f* deltaPh2 sf! ;
   
: mute2 0 ampl2 ! ;

: cbOsc \ Oscillator done by Forth as callback
   phase2 sf@ \ get phase
   48 0 do
      deltaPh2 sf@ f+ \ fdup f. \ add phase increment
      fdup fsin ampl2 sf@ f* \ calculate sine
      daisyAudio i cells + sf! \ store into buffer
   loop
   fdup 2pi f> if 2pi f- then 
   phase2 sf! \ store phase
;

\ cbosc \ fill the audio buffer
   
: daisyAudio. \ print audio buffer
   48 0 do
      daisyAudio i cells + sf@ f.
   loop
;

: audioLoop
   cbosc \ the oscillator done by Forth 
   fmodulate \ modulate the oscillator done by libDaisy
;

' audioloop audioxt ! \ activate callback

cpuload.


\ € End of Block

\ Other tests ########################################################
10 constant utilBlock   50 constant audioBlock
: ?ldMyBlocks if utilBlock load audioBlock load then ;
defined? f-3 0= ?ldMyBlocks

\ ######################################################################
\ to test the audioXT audioCallback
: ledTim
   MS-Ticks 300 / 1 and setLed ;

' ledTim audioXt ! \ set the interrupt handler
\ 0 audioXt ! \ to stop it


forth definitions tasks also internals
: kill-task { ktask } 
   0 0 { prevTask nextTask }
   task-list @ to nextTask
   begin
      ktask nextTask = if 
         nextTask 2 cells - see. \ show name of task
         ." killed! " 
         nextTask @ prevTask ! \ unlink from the list
      then
      nextTask to prevTask
      nextTask @ to nextTask
   nextTask task-list @ = until
;
 

\ Blinker Task
variable ledState 0 ledState !

: ledToggle
   begin
      ledState @ invert dup ledState ! 
      setLed
      300 ms
   again
   ;

' ledToggle 100 100 task blinkTask
blinkTask start-task

\ Fibotest

: fibo ( n -- f )  \ Fibonacci Reihe, letztes Ergebnis
    0 1 
    rot 2 - for 
        \ dup . 
        swap over \ tuck 
        + 
    next
    swap drop
;

: fibotest ( n -- ) \ Misst Zeit, geht bis 46
    US-TICKS

    swap fibo

    US-Ticks
    swap .
    swap
    -
    cr
    . ."  usecs "
;

46 fibotest 

\ Daisy ueForthC @400MHz fastest 4 us
\ Daisy ueForthC @400MHz smallest 6 us
\ ESP32 ESP32Forth @240MHz 16 us
\ Daisy CE_Forth_A 22 us @400MHz
\ ESP32 YAFFA Forth benoetigt 113 usec @240MHz  
\ direkt in Arduino C bei 240 MHz: 5µs (20* schneller)
\ micropython mit esp32: 727µs
\ picoC interpreter mit esp32: 724µs
\ lua in arduino mit esp32: 247µs
\ C:YAFFA-Forth:Lua:Micropython = 1:22:48:145
\ ( P2 TAQOZ braucht 2925 cycles 36,5 µs bei 80Mhz )


: Blocks_Library ; \ { ##################################################

\ block size is 4096 bytes !
create blockBuf 4096 allot
0 value updated
0 value actBlock

: update -1 to updated ;

: wipe \ wipe blockBuf
   4096 0 do 
   32 i blockBuf + c!
   loop ;
: € ; 
: \n\ ;

: buf. ( print blockbuffer to terminal ) \n\
    4096 0 do \n\
        blockbuf i + c@ dup emit \n\
        0 = if drop leave then \n\
    loop ; \n\

: getText ( -- ) ( receive text for a block via terminal into blockbuf until EuroSign ) \n\
    4096 0 do \n\
        ( cr i . ) key ( dup . ) \n\
        dup 128 = over 27 = or if ( ESC or Euro sign code 128 for end ) \n\
            drop 0 i blockbuf + c! ( NULL for end ) \n\
            leave \n\
        else \n\
            dup emit
            i blockbuf + c! \n\
        then \n\
    loop \n\
; \n\  

: flush
   updated if
      blockBuf actBlock putBlock
   then
   0 to updated
;

: block ( blocknumber ) \ get block into blockBuf
   updated if flush then
   dup blockBuf swap getBlock
   to actBlock
;

: buflen \ get length of blockBuf to NULL
   4096
   4096 0 do
      blockBuf i + c@ 0 = if 
         drop i leave 
      then
   loop
;
   
: list ( blocknumber ) \ get block into blockBuf and list
   ." Block: " dup .
   block
   buf.
;

: loadOne ( blocknumber ) \ get 1 block into blockBuf and evaluate
   block blockBuf buflen evaluate
;

0 value nextBlock
: --> actBlock 1+ to nextBlock ; \ chain next block

: load ( blocknumber ) \ evaluate the block, and more if --> has been included
   to nextBlock
   begin
      nextBlock loadOne
   actBlock nextBlock = until
;   
   
\ } Blocks_Library   


